## GoaManager GoaManager — Generated C code for the org.gnome.OnlineAccounts.Manager D-Bus interface |

## Functions

GDBusInterfaceInfo * | goa_manager_interface_info ()
guint | goa_manager_override_properties ()
void | goa_manager_call_add_account ()
gboolean | goa_manager_call_add_account_finish ()
gboolean | goa_manager_call_add_account_sync ()
void | goa_manager_complete_add_account ()
void | goa_manager_proxy_new ()
GoaManager * | goa_manager_proxy_new_finish ()
GoaManager * | goa_manager_proxy_new_sync ()
void | goa_manager_proxy_new_for_bus ()
GoaManager * | goa_manager_proxy_new_for_bus_finish ()
GoaManager * | goa_manager_proxy_new_for_bus_sync ()
GoaManager * | goa_manager_skeleton_new ()

## Signals

gboolean | handle-add-account | Run Last

## Types and Values

| GoaManager
struct | GoaManagerIface
struct | GoaManagerProxy
struct | GoaManagerProxyClass
struct | GoaManagerSkeleton
struct | GoaManagerSkeletonClass

## Object Hierarchy

        GInterface
        ╰── GoaManager
        GObject
        ├── GDBusInterfaceSkeleton
        │   ╰── GoaManagerSkeleton
        ╰── GDBusProxy
            ╰── GoaManagerProxy

## Prerequisites

GoaManager requires GObject.

## Implemented Interfaces

GoaManagerProxy implements GDBusInterface, GInitable, GAsyncInitable and GoaManager.

GoaManagerSkeleton implements GDBusInterface and GoaManager.

## Known Implementations

GoaManager is implemented by GoaManagerProxy and GoaManagerSkeleton.

## Description

This section contains code for working with the org.gnome.OnlineAccounts.Manager D-Bus interface in C.

## Functions

### goa_manager_interface_info ()

    GDBusInterfaceInfo *
    goa_manager_interface_info (void);

Gets a machine-readable description of the org.gnome.OnlineAccounts.Manager D-Bus interface.

#### Returns

A GDBusInterfaceInfo. Do not free.

[transfer none]

### goa_manager_override_properties ()

    guint
    goa_manager_override_properties (GObjectClass *klass,
                                     guint property_id_begin);

Overrides all GObject properties in the GoaManager interface for a concrete class. The properties are overridden in the order they are defined.

#### Parameters

klass | The class structure for a GObject-derived class. |
property_id_begin | The property id to assign to the first overridden property. |

#### Returns

The last property id.

### goa_manager_call_add_account ()

    void
    goa_manager_call_add_account (GoaManager *proxy,
                                  const gchar *arg_provider,
                                  const gchar *arg_identity,
                                  const gchar *arg_presentation_identity,
                                  GVariant *arg_credentials,
                                  GVariant *arg_details,
                                  GCancellable *cancellable,
                                  GAsyncReadyCallback callback,
                                  gpointer user_data);

Asynchronously invokes the `AddAccount()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `goa_manager_call_add_account_finish()` to get the result of the operation.

See `goa_manager_call_add_account_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A GoaManagerProxy. |
arg_provider | Argument to pass with the method invocation. |
arg_identity | Argument to pass with the method invocation. |
arg_presentation_identity | Argument to pass with the method invocation. |
arg_credentials | Argument to pass with the method invocation. |
arg_details | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### goa_manager_call_add_account_finish ()

    gboolean
    goa_manager_call_add_account_finish (GoaManager *proxy,
                                         gchar **out_account_object_path,
                                         GAsyncResult *res,
                                         GError **error);

Finishes an operation started with `goa_manager_call_add_account()`.

#### Parameters

proxy | A GoaManagerProxy. |
out_account_object_path | Return location for return parameter or `NULL` to ignore. | [out]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `goa_manager_call_add_account()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

### goa_manager_call_add_account_sync ()

    gboolean
    goa_manager_call_add_account_sync (GoaManager *proxy,
                                       const gchar *arg_provider,
                                       const gchar *arg_identity,
                                       const gchar *arg_presentation_identity,
                                       GVariant *arg_credentials,
                                       GVariant *arg_details,
                                       gchar **out_account_object_path,
                                       GCancellable *cancellable,
                                       GError **error);

Synchronously invokes the `AddAccount()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `goa_manager_call_add_account()` for the asynchronous version of this method.

#### Parameters

proxy | A GoaManagerProxy. |
arg_provider | Argument to pass with the method invocation. |
arg_identity | Argument to pass with the method invocation. |
arg_presentation_identity | Argument to pass with the method invocation. |
arg_credentials | Argument to pass with the method invocation. |
arg_details | Argument to pass with the method invocation. |
out_account_object_path | Return location for return parameter or `NULL` to ignore. | [out]
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

### goa_manager_complete_add_account ()

    void
    goa_manager_complete_add_account (GoaManager *object,
                                      GDBusMethodInvocation *invocation,
                                      const gchar *account_object_path);

Helper function used in service implementations to finish handling invocations of the `AddAccount()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A GoaManager. |
invocation | A GDBusMethodInvocation. | [transfer full]
account_object_path | Parameter to return. |

### goa_manager_proxy_new ()

    void
    goa_manager_proxy_new (GDBusConnection *connection,
                           GDBusProxyFlags flags,
                           const gchar *name,
                           const gchar *object_path,
                           GCancellable *cancellable,
                           GAsyncReadyCallback callback,
                           gpointer user_data);

Asynchronously creates a proxy for the D-Bus interface org.gnome.OnlineAccounts.Manager. See `g_dbus_proxy_new()` for more details.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `goa_manager_proxy_new_finish()` to get the result of the operation.

See `goa_manager_proxy_new_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [allow-none]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### goa_manager_proxy_new_finish ()

    GoaManager *
    goa_manager_proxy_new_finish (GAsyncResult *res,
                                  GError **error);

Finishes an operation started with `goa_manager_proxy_new()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `goa_manager_proxy_new()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type GoaManagerProxy]

### goa_manager_proxy_new_sync ()

    GoaManager *
    goa_manager_proxy_new_sync (GDBusConnection *connection,
                                GDBusProxyFlags flags,
                                const gchar *name,
                                const gchar *object_path,
                                GCancellable *cancellable,
                                GError **error);

Synchronously creates a proxy for the D-Bus interface org.gnome.OnlineAccounts.Manager. See `g_dbus_proxy_new_sync()` for more details.

The calling thread is blocked until a reply is received.

See `goa_manager_proxy_new()` for the asynchronous version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [allow-none]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type GoaManagerProxy]

### goa_manager_proxy_new_for_bus ()

    void
    goa_manager_proxy_new_for_bus (GBusType bus_type,
                                   GDBusProxyFlags flags,
                                   const gchar *name,
                                   const gchar *object_path,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

Like `goa_manager_proxy_new()` but takes a GBusType instead of a GDBusConnection.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `goa_manager_proxy_new_for_bus_finish()` to get the result of the operation.

See `goa_manager_proxy_new_for_bus_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### goa_manager_proxy_new_for_bus_finish ()

    GoaManager *
    goa_manager_proxy_new_for_bus_finish (GAsyncResult *res,
                                          GError **error);

Finishes an operation started with `goa_manager_proxy_new_for_bus()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `goa_manager_proxy_new_for_bus()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type GoaManagerProxy]

### goa_manager_proxy_new_for_bus_sync ()

    GoaManager *
    goa_manager_proxy_new_for_bus_sync (GBusType bus_type,
                                        GDBusProxyFlags flags,
                                        const gchar *name,
                                        const gchar *object_path,
                                        GCancellable *cancellable,
                                        GError **error);

Like `goa_manager_proxy_new_sync()` but takes a GBusType instead of a GDBusConnection.

The calling thread is blocked until a reply is received.

See `goa_manager_proxy_new_for_bus()` for the asynchronous version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type GoaManagerProxy]

### goa_manager_skeleton_new ()

    GoaManager *
    goa_manager_skeleton_new (void);

Creates a skeleton object for the D-Bus interface org.gnome.OnlineAccounts.Manager.

#### Returns

The skeleton object.

[transfer full][type GoaManagerSkeleton]

## Types and Values

### GoaManager

    typedef struct _GoaManager GoaManager;

Abstract interface type for the D-Bus interface org.gnome.OnlineAccounts.Manager.

### struct GoaManagerIface

    struct GoaManagerIface {
      GTypeInterface parent_iface;

      gboolean (*handle_add_account) (
        GoaManager *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_provider,
        const gchar *arg_identity,
        const gchar *arg_presentation_identity,
        GVariant *arg_credentials,
        GVariant *arg_details);
    };

Virtual table for the D-Bus interface org.gnome.OnlineAccounts.Manager.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_add_account` () | Handler for the “handle-add-account” signal. |

### struct GoaManagerProxy

    struct GoaManagerProxy;

The GoaManagerProxy structure contains only private data and should only be accessed using the provided API.

### struct GoaManagerProxyClass

    struct GoaManagerProxyClass {
      GDBusProxyClass parent_class;
    };

Class structure for GoaManagerProxy.

#### Members

### struct GoaManagerSkeleton

    struct GoaManagerSkeleton;

The GoaManagerSkeleton structure contains only private data and should only be accessed using the provided API.

### struct GoaManagerSkeletonClass

    struct GoaManagerSkeletonClass {
      GDBusInterfaceSkeletonClass parent_class;
    };

Class structure for GoaManagerSkeleton.

#### Members

## Signal Details

### The `“handle-add-account”` signal

    gboolean
    user_function (GoaManager            *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_provider,
                   gchar                 *arg_identity,
                   gchar                 *arg_presentation_identity,
                   GVariant              *arg_credentials,
                   GVariant              *arg_details,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `AddAccount()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `goa_manager_complete_add_account()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A GoaManager. |
invocation | A GDBusMethodInvocation. |
arg_provider | Argument passed by remote caller. |
arg_identity | Argument passed by remote caller. |
arg_presentation_identity | Argument passed by remote caller. |
arg_credentials | Argument passed by remote caller. |
arg_details | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last